﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class PlayerNumText : MonoBehaviour
{
    [SerializeField]
    MatchingManager matchingManager;

    // 同じくアタッチされている「現在この部屋にはXX/XX人います！」
    Text text;

    // ルームの定員
    int maxPlayerNum;
    // ルームに現在いる人の数
    int nowPlayerNum;

    // Use this for initialization
    void Start ()
    {
        text = GetComponent<Text>();
        text.text = "接続中";
    }
    
    // Update is called once per frame
    void Update ()
    {
        RenderText();

        if (matchingManager.NowPlayerNum == matchingManager.MaxPlayerNum)
        {
            GoToNextScene();
        }
    }

    // 現在何人ルームにいるかを描画する。
    void RenderText()
    {
        int nowPlayerNum = matchingManager.NowPlayerNum;

        if (nowPlayerNum == 0)
        {
            // 接続中... を表示
            Connecting();

            return;
        }

        text.text = "現在この部屋には" + nowPlayerNum + "/" + matchingManager.MaxPlayerNum + "人います！";
    }


    // 現在表示されている、「接続中」の後の点の数
    int nowDotNum = 0;

    // 「接続中...」の表示
    // RenderText()から呼び出される
    void Connecting()
    {
        const int maxDotNum = 3;

        if (Time.frameCount % 30 == 0)
        {
            text.text = "接続中";
            // 「接続中」の後に"."をいくつか描画
            for (int i = 0; i < nowDotNum; i++)
            {
                text.text += ".";
            }

            // 表示されているドットの数がmaxDotNumよりも多くなったらドットを無くしループ
            nowDotNum++;
            if (maxDotNum < nowDotNum)
            {
                nowDotNum = 0;
            }
        }
    }

    void GoToNextScene()
    {
        SceneManager.LoadScene("Game");
    }
}
